<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:fn="http://xmlns.jcp.org/jsp/jstl/functions">
<h:head>
    <title>АРМ Сотрудника по стандартизации</title>
</h:head>
<h:body>
    <style type="text/css">
        .old {
            background-color: #666699 !important;
            background-image: none !important;
            color: #003399 !important;
        }

        .nondelivered {
            background-color: #ff0000 !important;
            background-image: none !important;
            color: #000000 !important;
        }
    </style>

    <p:dialog header="Стандарт" widgetVar="standartEditDlg" modal="true" showEffect="fade" hideEffect="fade"
              resizable="false" appendToBody="false" blockScroll="true">

        <p:outputPanel id="standartEditDlgPanel" style="text-align:center;">
            <h:form id="standartEditForm">
                <p:outputPanel>
                    <p:dataTable id="standrtTypeSeelcted" var="selectedSt" value="#{standartView.standartTypes}"
                                 selection="#{standartView.selected.type}" rowKey="#{selectedSt.id}"
                                 tableStyle="table-layout: auto !important;" scrollable="true" scrollHeight="100">
                        <p:ajax event="rowSelectRadio" update="standrtTypeSeelcted"/>
                        <f:facet name="header">
                            Тип стандарта: #{standartView.selected.type.code}
                        </f:facet>
                        <p:column selectionMode="single" style="width:16px;text-align:center"/>
                        <p:column>
                            <h:outputText value="#{selectedSt.code}"/>
                        </p:column>
                    </p:dataTable>
                </p:outputPanel>
                <p:panelGrid columns="2" rendered="#{not empty standartView.selected}"
                             columnClasses="label,value" id="stEditPanelGrid">
                    <h:outputText value="Регистрационный номер: "/>
                    <p:inputText id="stregum" value="#{standartView.selected.regNum}"/>
                    <h:outputText value="Наименование: "/>
                    <p:inputText id="stfn" value="#{standartView.selected.name}"/>
                    <h:outputText value="Статус: "/>
                    <p:selectBooleanCheckbox id="stisact" value="#{standartView.selected.isActive}"
                                             itemLabel="Активный"/>
                    <h:outputText value="Электнронная копия: "/>
                    <p:outputPanel id="standartPdfPanel">
                        <h:outputText value="#{standartView.selected.hasElectronicCopy ? 'Есть': 'Нет'}"/>
                        <p:commandButton icon="ui-icon-circle-zoomin" oncomplete="PF('showPdf').show()"
                                         immediate="true" update="showPdfPanel"
                                         rendered="#{standartView.selected.hasElectronicCopy}"/>
                        <p:fileUpload fileUploadListener="#{standartView.fileUploadListener}"
                                      value="#{standartView.file}" mode="advanced" multiple="false" auto="true"
                                      update="standartPdfPanel"
                                      rendered="#{not standartView.selected.hasElectronicCopy}"/>
                        <p:commandButton icon="ui-icon-closethick" action="#{standartView.deleteElectronicCopy}"
                                         immediate="true" update="standartPdfPanel"
                                         rendered="#{standartView.selected.hasElectronicCopy}"/>
                    </p:outputPanel>
                    <h:outputText value="Местонахождение физической копии: "/>
                    <p:inputText id="stcoploc" value="#{standartView.selected.mainCopyLocation}"/>
                </p:panelGrid>
                <p:outputPanel>
                    <p:dataTable id="standartPred" var="selectedPre" value="#{standartView.predecessors}"
                                 widgetVar="standartPredWV"
                                 selectionMode="single" filteredValue="#{standartView.filteredPredecessors}"
                                 selection="#{standartView.selected.predecessor}" rowKey="#{selectedPre.id}"
                                 scrollable="true" scrollHeight="200"
                                 tableStyle="table-layout: auto !important;">
                        <f:facet name="header">
                            Заменяет стандарт:
                            <p:outputPanel>
                                <p:inputText id="globalFilter" onkeyup="PF('standartPredWV').filter()"
                                             style="width:150px" placeholder="Введите номер стандарта"/>
                            </p:outputPanel>
                        </f:facet>
                        <p:column>
                            <h:outputText value="#{selectedPre.type.code.concat(' ').concat(selectedPre.regNum)}"/>
                        </p:column>
                    </p:dataTable>
                    <p:commandButton value="Сохранить" icon="ui-icon-disk"
                                     update="mainTabView:productTabView:standartMainForm:dtStandarts"
                                     actionListener="#{standartView.update}"
                                     process="@this stregum stisact stfn standrtTypeSeelcted standartPred stcoploc"
                                     oncomplete="PF('standartEditDlg').hide();">
                    </p:commandButton>
                </p:outputPanel>
            </h:form>
        </p:outputPanel>
    </p:dialog>

    <p:tabView orientation="left" id="mainTabView">
        <p:tab title="Стандарты и изделия">
            <p:tabView id="productTabView">
                <p:tab title="Изделия">
                    <h:form id="productForm">
                        <p:dataTable id="dtProducts" var="product" value="#{productView.products}"
                                     selectionMode="single" selection="#{productView.selected}" rowKey="#{product.id}"
                                     editable="true">
                            <p:ajax event="rowSelect"
                                    update="mainTabView:productTabView:productForm:productToStandart"/>
                            <p:column headerText="Наименование">
                                <h:outputText value="#{product.name}"/>
                            </p:column>
                            <p:column headerText="Описание">
                                <h:outputText value="#{product.desciption}"/>
                            </p:column>
                            <p:column>
                                <p:commandButton icon="ui-icon-plusthick" oncomplete="PF('productDlg').show()"
                                                 immediate="true" process="@this" update="productViewDlgPanel">
                                    <f:setPropertyActionListener value="#{product}" target="#{productView.selected}"/>
                                </p:commandButton>
                            </p:column>
                        </p:dataTable>
                        <p:separator/>
                        <p:dataTable id="productToStandart" var="standart" value="#{productView.selected.standarts}"
                                     tableStyle="table-layout: auto !important;">
                            <f:facet name="header">
                                Стандарты изделия
                            </f:facet>
                            <p:column headerText="Стандарт">
                                <h:outputText value="#{standart.type.code.concat(' ').concat(standart.regNum)}"/>
                            </p:column>
                            <p:column headerText="Наименование">
                                <h:outputText value="#{standart.name}"/>
                            </p:column>
                        </p:dataTable>
                        <p:commandButton id="prodStandPrinter" value="Распечатать стандарты изделия"
                                         icon="ui-icon-print">
                            <p:printer target="productToStandart"/>
                        </p:commandButton>
                    </h:form>
                </p:tab>
                <p:tab title="Стандарты">
                    <h:form id="standartMainForm">
                        <p:dataTable id="dtStandarts" var="standart" value="#{standartView.standarts}"
                                     selection="#{standartView.selected}"
                                     filteredValue="#{standartView.filteredStandarts}"
                                     selectionMode="single"
                                     rowKey="#{standart.id}"
                                     rowStyleClass="#{standart.isActive ? null : 'old'}">
                            <p:column headerText="Номер"
                                      filterBy="#{standart.type.code.concat(' ').concat(standart.regNum)}"
                                      filterMatchMode="contains">
                                <h:outputText value="#{standart.type.code.concat(' ').concat(standart.regNum)}"/>
                            </p:column>
                            <p:column headerText="Наименование">
                                <h:outputText value="#{standart.name}"/>
                            </p:column>
                            <p:column>
                                <p:commandButton icon="ui-icon-circle-zoomin" oncomplete="PF('standartViewDlg').show()"
                                                 immediate="true" process="@this" update="standartViewDlgPanel">
                                    <f:setPropertyActionListener value="#{standart}" target="#{standartView.selected}"/>
                                </p:commandButton>
                                <p:commandButton icon="ui-icon-pencil" oncomplete="PF('standartEditDlg').show()"
                                                 immediate="true" process="@this standartEditDlgPanel"
                                                 update="standartEditDlgPanel">
                                    <f:setPropertyActionListener value="#{standart}"
                                                                 target="#{standartView.selected}"/>
                                </p:commandButton>
                            </p:column>
                        </p:dataTable>
                        <p:commandButton title="Добавить запись" oncomplete="PF('standartEditDlg').show()"
                                         immediate="true" process="@this" update="standartEditDlgPanel"
                                         action="#{standartView.prepareNew}">
                        </p:commandButton>
                    </h:form>
                </p:tab>
            </p:tabView>
        </p:tab>
        <p:tab title="Справочники">
            <p:tabView id="dictTabView">
                <p:tab title="Типы Стандартов">
                    <h:form id="standartTypeForm">
                        <p:dataTable id="standartTypes" var="standartType" value="#{standartTypeView.standartTypes}"
                                     selection="#{standartTypeView.selected}" selectionMode="single"
                                     rowKey="#{standartType.id}"
                                     sortBy="#{standartType.code}">
                            <p:column headerText="Наименование типа стандарта" width="85%">
                                <h:outputText value="#{standartType.code}"/>
                            </p:column>
                        </p:dataTable>
                    </h:form>
                </p:tab>
                <p:tab title="Подразделения">
                    <h:form id="departmentForm">
                        <p:dataTable id="deps" var="department" value="#{departmentView.departments}"
                                     selection="#{departmentView.selected}" selectionMode="single"
                                     rowKey="#{department.id}">
                            <p:column headerText="Наименование Отдела" width="85%">
                                <h:outputText value="#{department.name}"/>
                            </p:column>
                            <p:column width="15%" headerText="Действия">
                                <p:commandButton icon="ui-icon-pencil" oncomplete="PF('editDepDialog').show()"
                                                 immediate="true" process="@this" update="editDepartment">
                                    <f:setPropertyActionListener value="#{department}"
                                                                 target="#{departmentView.selected}"/>
                                </p:commandButton>
                                <p:commandButton update="deps"
                                                 type="submit"
                                                 action="#{departmentView.delete(department)}"
                                                 process="@this"
                                                 immediate="true"
                                                 icon="ui-icon-closethick">
                                    <p:confirm header="Подтверждение операции"
                                               message="Вы уверены, что хотите выполнить операцию?"/>
                                </p:commandButton>
                            </p:column>
                        </p:dataTable>
                        <p:commandButton title="Добавить запись" oncomplete="PF('editDepDialog').show()"
                                         immediate="true" process="@this" update="editDepartment"
                                         action="#{departmentView.prepareNew}">
                        </p:commandButton>
                    </h:form>
                </p:tab>
            </p:tabView>
        </p:tab>
        <p:tab title="Журнал приема/выдачи документов">
            <h:form id="standartLogForm">
                <p:outputPanel>
                    <p:dataTable id="standartLogs" value="#{standartKeepingLogView.logs}" var="sLog"
                                 selection="#{standartKeepingLogView.selected}"
                                 selectionMode="single" rowKey="#{sLog.id}"
                                 rowStyleClass="#{(not empty sLog.dateEnd) ? null : 'nondelivered'}">
                        <p:column style="width:16px">
                            <p:rowToggler/>
                        </p:column>
                        <p:column headerText="Отдел">
                            <h:outputText value="#{sLog.location.name}"/>
                        </p:column>
                        <p:column headerText="Дата выдачи">
                            <h:outputText value="#{sLog.dateStart}">
                                <f:convertDateTime pattern="dd.MM.yyyy"/>
                            </h:outputText>
                        </p:column>
                        <p:column headerText="Дата возврата">
                            <h:outputText value="#{sLog.dateEnd}">
                                <f:convertDateTime pattern="dd.MM.yyyy"/>
                            </h:outputText>
                        </p:column>
                        <p:column headerText="Выдано документов">
                            <h:outputText value="#{fn:length(sLog.standarts)}"/>
                        </p:column>
                        <p:column>
                            <p:commandButton icon="ui-icon-pencil" oncomplete="PF('logEditDialog').show()"
                                             immediate="true" process="@this" update="editLogPanel">
                                <f:setPropertyActionListener value="#{sLog}"
                                                             target="#{standartKeepingLogView.selected}"/>
                            </p:commandButton>
                        </p:column>
                        <p:rowExpansion>
                            <p:dataTable value="#{sLog.standarts}" var="sLogStandart">
                                <p:column headerText="Номер документа">
                                    <h:outputText
                                            value="#{sLogStandart.type.code.concat(' ').concat(sLogStandart.regNum)}"/>
                                </p:column>
                                <p:column headerText="Наименование документа">
                                    <h:outputText value="#{sLogStandart.name}"/>
                                </p:column>
                            </p:dataTable>
                        </p:rowExpansion>
                    </p:dataTable>
                    <p:commandButton title="Добавить запись" oncomplete="PF('logEditDialog').show()"
                                     immediate="true" process="@this" update="editLogPanel"
                                     action="#{standartKeepingLogView.prepareNew}">
                    </p:commandButton>
                </p:outputPanel>
            </h:form>
        </p:tab>
    </p:tabView>

    <p:dialog header="Запись в журнале приема/выдачи" widgetVar="logEditDialog" modal="true" showEffect="fade"
              hideEffect="fade"
              resizable="false">
        <p:outputPanel id="editLogPanel">
            <h:form>
                <p:outputPanel>
                    <p:dataTable id="logDepartment" var="logSelDep" value="#{standartKeepingLogView.departments}"
                                 selection="#{standartKeepingLogView.selected.location}" rowKey="#{logSelDep.id}"
                                 tableStyle="table-layout: auto !important;" scrollable="true" scrollHeight="100">
                        <p:ajax event="rowSelectRadio" update="logDepartment"/>
                        <f:facet name="header">
                            Отдел: #{standartKeepingLogView.selected.location.name}
                        </f:facet>
                        <p:column selectionMode="single" style="width:16px;text-align:center"/>
                        <p:column>
                            <h:outputText value="#{logSelDep.name}"/>
                        </p:column>
                    </p:dataTable>
                </p:outputPanel>
                <p:panelGrid id="logStandartFieldsEditPanel" columns="2"
                             rendered="#{not empty standartKeepingLogView.selected}"
                             columnClasses="label,value">
                    <h:outputText value="Описание"/>
                    <p:inputText value="#{standartKeepingLogView.selected.description}"/>
                    <h:outputText value="Дата выдачи: "/>
                    <p:datePicker value="#{standartKeepingLogView.selected.dateStart}"/>
                    <h:outputText value="Дата приема: "/>
                    <p:datePicker value="#{standartKeepingLogView.selected.dateEnd}"/>
                </p:panelGrid>
                <p:dataTable id="standartLogStandart" var="logStand" value="#{standartKeepingLogView.standarts}"
                             selectionMode="multiple" filteredValue="#{standartKeepingLogView.filteredLogStandarts}"
                             selection="#{standartKeepingLogView.selected.standarts}" rowKey="#{logStand.id}"
                             scrollable="true" scrollHeight="200"
                             tableStyle="table-layout: auto !important;">
                    <f:facet name="header">
                        Стандарты
                    </f:facet>
                    <p:column>
                        <h:outputText value="#{logStand.type.code.concat(' ').concat(logStand.regNum)}"/>
                    </p:column>
                </p:dataTable>
                <p:commandButton value="Сохранить" icon="ui-icon-disk"
                                 update="mainTabView:standartLogForm:standartLogs"
                                 process="@this logDepartment logStandartFieldsEditPanel standartLogStandart"
                                 action="#{standartKeepingLogView.update()}"
                                 oncomplete="PF('logEditDialog').hide();">
                </p:commandButton>
            </h:form>
        </p:outputPanel>
    </p:dialog>

    <p:dialog header="Отдел" widgetVar="editDepDialog" modal="true" showEffect="fade" hideEffect="fade"
              resizable="false">
        <p:outputPanel id="editDepartment" style="text-align:center;">
            <h:form>
                <p:panelGrid columns="2" rendered="#{not empty departmentView.selected}"
                             columnClasses="label,value">
                    <h:outputText value="Наименование: "/>
                    <p:inputText value="#{departmentView.selected.name}"/>
                </p:panelGrid>
                <p:commandButton value="Сохранить" icon="ui-icon-disk"
                                 update="mainTabView:dictTabView:departmentForm:deps"
                                 action="#{departmentView.update()}"
                                 oncomplete="PF('editDepDialog').hide();">
                </p:commandButton>
            </h:form>
        </p:outputPanel>
    </p:dialog>

    <p:dialog header="Изделие" widgetVar="productDlg" modal="true" showEffect="fade" hideEffect="fade"
              resizable="true">
        <p:outputPanel id="productViewDlgPanel" style="text-align:center;">
            <h:form>
                <p:panelGrid columns="2" rendered="#{not empty productView.selected}"
                             columnClasses="label,value">
                    <h:outputText value="Наименование: "/>
                    <h:outputText value="#{productView.selected.name}"/>
                    <h:outputText value="Описание: "/>
                    <h:outputText value="#{productView.selected.desciption}"/>
                </p:panelGrid>
                <p:dataTable id="standrtsForProds" var="standart" value="#{standartView.standarts}"
                             rowKey="#{standart.id}" selection="#{productView.selected.standarts}"
                             tableStyle="table-layout: auto !important;"
                             filteredValue="#{productView.filteredStandarts}">
                    <p:column selectionMode="multiple" style="width:16px;text-align:center"/>
                    <p:column headerText="Стандарт" filterBy="#{standart.type.code.concat(' ').concat(standart.regNum)}"
                              filterMatchMode="contains">
                        <h:outputText value="#{standart.type.code.concat(' ').concat(standart.regNum)}"/>
                    </p:column>
                    <p:column headerText="Наименование">
                        <h:outputText value="#{standart.name}"/>
                    </p:column>
                </p:dataTable>
                <p:commandButton value="Сохранить" icon="ui-icon-disk"
                                 update="mainTabView:productTabView:productForm:dtProducts"
                                 action="#{productView.update()}"
                                 oncomplete="PF('productDlg').hide();">
                </p:commandButton>

            </h:form>
        </p:outputPanel>
    </p:dialog>

    <p:dialog header="Стандарт" widgetVar="standartViewDlg" modal="true" showEffect="fade" hideEffect="fade"
              resizable="false">
        <p:outputPanel id="standartViewDlgPanel" style="text-align:left;">
            <p:panelGrid columns="2" rendered="#{not empty standartView.selected}"
                         columnClasses="label,value">
                <h:outputText value="Тип стандарта: "/>
                <h:outputText value="#{standartView.selected.type.code}"/>
                <h:outputText value="Регистрационный номер: "/>
                <h:outputText value="#{standartView.selected.regNum}"/>
                <h:outputText value="Наименование: "/>
                <h:outputText value="#{standartView.selected.name}"/>
                <h:outputText value="Статус: "/>
                <h:outputText value="#{standartView.selected.isActive ? 'Активный': 'Неактивный'}"/>
                <h:outputText value="Электнонная копия: "/>
                <p:outputPanel>
                    <h:outputText value="#{standartView.selected.hasElectronicCopy ? 'Есть': 'Нет'}"/>
                    <p:commandButton icon="ui-icon-circle-zoomin" oncomplete="PF('showPdf').show()"
                                     immediate="true" update="showPdfPanel"
                                     rendered="#{standartView.selected.hasElectronicCopy}"/>
                </p:outputPanel>
                <h:outputText value="Местонахождение физической копии: "/>
                <h:outputText value="#{standartView.selected.mainCopyLocation}" escape="false"/>
            </p:panelGrid>
        </p:outputPanel>
    </p:dialog>


    <p:dialog widgetVar="showPdf">
        <p:outputPanel id="showPdfPanel" style="width: 100%; height: 100%;">
            <p:media value="#{standartView.selected.pathToDocument}" width="100%" height="100%"
                     rendered="#{standartView.selected.hasElectronicCopy}">
                Your browser can't display pdf, <h:outputLink
                    value="#{standartView.selected.pathToDocument}">click</h:outputLink> to download pdf instead.
            </p:media>
        </p:outputPanel>
    </p:dialog>

    <p:dialog widgetVar="loadFile">
        <p:fileUpload fileUploadListener="#{standartView.fileUploadListener}"
                      value="#{standartView.file}" mode="advanced" multiple="false" auto="true"
                      update="standartEditDlgPanel"/>
    </p:dialog>

    <p:confirmDialog global="true" showEffect="fade" hideEffect="fade">
        <p:commandButton value="Да" type="button" styleClass="ui-confirmdialog-yes"/>
        <p:commandButton value="Нет" type="button" styleClass="ui-confirmdialog-no"/>
    </p:confirmDialog>
</h:body>
</html>
